Ruby 2.5.0 リファレンスマニュアル > ライブラリ一覧 > 組み込みライブラリ > Exceptionクラス

class Exception

クラスの継承リスト: Exception < Object < Kernel < BasicObject

要約

全ての例外の祖先のクラスです。

目次

特異メソッド
exception new
インスタンスメソッド
== backtrace backtrace_locations cause exception full_message inspect message to_s set_backtrace

特異メソッド

new(error_message = nil) -> Exception[permalink][rdoc]
exception(error_message = nil) -> Exception

例外オブジェクトを生成して返します。

[PARAM] error_message:
エラーメッセージを表す文字列を指定します。このメッセージは 属性 Exception#message の値になり、デフォルトの例外ハンドラで表示されます。

例:

e = Exception.new("some message")
p e         # => #<Exception: some message>
p e.message # => "some message"

例:

e = Exception.exception("some message")
p e         # => #<Exception: some message>
p e.message # => "some message"

インスタンスメソッド

self == other -> bool[permalink][rdoc]

自身と指定された other のクラスが同じであり、 message と backtrace が == メソッドで比較して 等しい場合に true を返します。そうでない場合に false を返します。

[PARAM] other:
自身と比較したいオブジェクトを指定します。 自身と異なるクラスのオブジェクトを指定した場合は Exception#exception を実行して変換を試みます。
backtrace -> [String][permalink][rdoc]

バックトレース情報を返します。

デフォルトでは

という形式の String の配列です。

def methd
  raise
end

begin
  methd
rescue => e
  p e.backtrace
end

#=> ["filename.rb:2:in `methd'", "filename.rb:6"]

[SEE_ALSO] Exception#backtrace_locations

backtrace_locations -> [Thread::Backtrace::Location][permalink][rdoc]

バックトレース情報を返します。Exception#backtraceに似ていますが、 Thread::Backtrace::Location の配列を返す点が異なります。

現状では Exception#set_backtrace によって戻り値が変化する事はあり ません。

例: test.rb

require "date"
def check_long_month(month)
  return if Date.new(2000, month, -1).day == 31
  raise "#{month} is not long month"
end

def get_exception
  return begin
    yield
  rescue => e
    e
  end
end

e = get_exception { check_long_month(2) }
p e.backtrace_locations
# => ["test.rb:4:in `check_long_month'", "test.rb:15:in `block in <main>'", "test.rb:9:in `get_exception'", "test.rb:15:in `<main>'"]

[SEE_ALSO] Exception#backtrace

cause -> Exception | nil[permalink][rdoc]

self の前の例外(self が rescue 節や ensure 節の中で発生した例外の場合、 その前に発生していた元々の例外)を返します。存在しない場合は nil を返し ます。

例:

begin
  begin
    raise "inner"
  rescue
    raise "outer"
  end
rescue
  p $!       # => #<RuntimeError: outer>
  p $!.cause # => #<RuntimeError: inner>
end
exception -> self[permalink][rdoc]
exception(error_message) -> Exception

引数を指定しない場合は self を返します。引数を指定した場合 自身のコピー を生成し Exception#message 属性を error_message にして返します。

Kernel.#raise は、実質的に、例外オブジェクトの exception メソッドの呼び出しです。

[PARAM] error_message:
エラーメッセージを表す文字列を指定します。
begin
 ...        # 何か処理
rescue => e
 raise e.exception("an error occurs during hogehoge process")  # 詳しいエラーメッセージ
end
full_message -> String[permalink][rdoc]

例外の整形された文字列を返します。

返される文字列は Ruby が捕捉されなかった例外を標準エラー出力に出力するときと 同じ形式です。 そのため、$stderr が変更されておらず、$stderr.tty? が真の場合はエスケープシーケンスによる文字装飾がついています。

[注意] このメソッドは実験的な機能として提供されています。仕様が変更にな る可能性があります。



begin
  raise "test"
rescue => e
  p e.full_message   # => "\e[1mTraceback \e[m(most recent call last):\ntest.rb:2:in `<main>': \e[1mtest (\e[4;1mRuntimeError\e[m\e[1m)\n\e[m"
  $stderr = $stdout
  p e.full_message   # => "test.rb:2:in `<main>': test (RuntimeError)\n"
  $stderr = STDERR
  p e.full_message   # => "\e[1mTraceback \e[m(most recent call last):\ntest.rb:2:in `<main>': \e[1mtest (\e[4;1mRuntimeError\e[m\e[1m)\n\e[m"
end
inspect -> String[permalink][rdoc]

self のクラス名と message を文字列にして返します。

例:

begin
  raise "exception"
rescue
  p $!.inspect # => "#<RuntimeError: exception>"
end
message -> String[permalink][rdoc]
to_s -> String

エラーメッセージをあらわす文字列を返します。

begin
  1 + nil
rescue => e
  p e.message   #=>  "nil can't be coerced into Fixnum"
end
set_backtrace(errinfo) -> nil | String | [String][permalink][rdoc]

バックトレース情報に errinfo を設定し、設定されたバックトレース 情報を返します。

[PARAM] errinfo:
nil、String あるいは String の配列のいずれかを指定します。
例:

begin
  begin
    raise "inner"
  rescue
    raise "outer"
  end
rescue
  $!.backtrace # => ["/path/to/test.rb:5:in `rescue in <main>'", "/path/to/test.rb:2:in `<main>'"]
  $!.set_backtrace(["dummy1", "dummy2"])
  $!.backtrace # => ["dummy1", "dummy2"]
end